#include <amxmodx>
#include <xs>
#include <fakemeta>
#include <hamsandwich>
#include <fakemeta_util>
#pragma semicolon 1
#pragma ctrlchar  '\'

#define PLUGIN "Egon Freezer"
#define VERSION "1.1.8b"
#define AUTHOR "BIGs"


#define FFADE_IN 0x0000 // Just here so we don't pass 0 into the function
#define FFADE_OUT 0x0001 // Fade out (not in)
#define FFADE_MODULATE 0x0002 // Modulate (don't blend)
#define FFADE_STAYOUT 0x0004 // ignores the duration, stays faded out until new ScreenFade message received

//Cvars
new Float:ef_damage  , ef_unfreeze_time ;
new ef_push ;


new const gModelGlass[] = "models/glassgibs.mdl";
new gGlass;
public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	RegisterHam(Ham_TakeDamage, "player", "UserTakeDamage");
	RegisterHam(Ham_Spawn,"player","player_respawn");
	
	
	//Cvars
	ef_damage = register_cvar("ef_damage" , "5.0");
	ef_unfreeze_time = register_cvar("ef_unfreeze_time" , "5.0");
	ef_push = register_cvar("ef_push" , "50");
	server_print("[EgonFreezer] Version : %s" ,VERSION);
}
public player_respawn(id)
{
	if(id <= get_maxplayers() && id != 0)
	{
	//Delete Fade screen
		message_begin(MSG_ONE, get_user_msgid("ScreenFade"), {0,0,0}, id);
		write_short(1<<12); //Duration 112 == 1 second
		write_short(1<<12); //HoldTime 112 == 1 second
		write_short(FFADE_IN | FFADE_STAYOUT);
		write_byte(0); // R [0-255]
		write_byte(0); // G [0-255]
		write_byte(0); // B [0-255]
		write_byte(0); // opacity [0-255]
		message_end();
		
	//Return default speed
		set_pev(id, pev_maxspeed ,320.0);
	//Delete Ice Shell
		fm_set_rendering(id);
	}
}
public plugin_precache()
{
	gGlass = precache_model(gModelGlass);
}
public UserTakeDamage(victim, weapon, attacker, Float:damage, damage_type)
{
	if(victim <= get_maxplayers() && victim != 0 && attacker <= get_maxplayers() && attacker != 0)
	{
		new Weapon;
		Weapon = get_user_weapon(attacker);
		new Red ,Green,Blue;
		
		if(Weapon == HLW_EGON)
		{
			
		//Damage
			new Float:damage = get_pcvar_float(ef_damage);
			SetHamParamFloat(4 ,damage);
	
		//Cold Speed
			set_pev(victim , pev_maxspeed ,100.0);
			
		//Ice Shell
			Red = 66;
			Green = 170;
			Blue = 255;
			fm_set_rendering(victim,kRenderFxGlowShell,Red,Green,Blue,kRenderNormal,25);
			
		//Fade screen
			message_begin(MSG_ONE, get_user_msgid("ScreenFade"), {0,0,0}, victim);
			write_short(1<<12); //Duration 112 == 1 second
			write_short(1<<12); //HoldTime 112 == 1 second
			write_short(FFADE_IN | FFADE_STAYOUT);
			write_byte(66); // R [0-255]
			write_byte(170); // G [0-255]
			write_byte(255); // B [0-255]
			write_byte(100); // opacity [0-255]
			message_end();
			
		//Frost Icon
			message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("StatusIcon")  , {0, 0, 0}, victim);
			write_byte(1);
			write_string("dmg_cold");
			write_byte(66); // red
			write_byte(170); // green
			write_byte(255); // blue
			message_end(); 
			
			set_task(get_pcvar_float(ef_unfreeze_time) ,"un_froze" ,victim);
	
		//Thanks Turanga_Leela
			static Float:v_agle[3], Float:speed[3];
			pev(attacker, pev_v_angle, v_agle);
			
			angle_vector(v_agle, ANGLEVECTOR_FORWARD, v_agle);
			xs_vec_mul_scalar(v_agle, 2.0 *-get_pcvar_num(ef_push), v_agle);
				
			pev(attacker, pev_velocity, speed);
			xs_vec_add(speed, v_agle, speed);
	
			set_pev(attacker, pev_velocity, speed);
			
		}
	}
}
public un_froze(taskid)
{
	new victim = taskid;
	if(victim <= get_maxplayers() && victim != 0)
	{
	//Delete Fade screen
		message_begin(MSG_ONE, get_user_msgid("ScreenFade"), {0,0,0}, victim);
		write_short(1<<12); //Duration 112 == 1 second
		write_short(1<<12); //HoldTime 112 == 1 second
		write_short(FFADE_IN | FFADE_STAYOUT);
		write_byte(0); // R [0-255]
		write_byte(0); // G [0-255]
		write_byte(0); // B [0-255]
		write_byte(0); // opacity [0-255]
		message_end();
	
		static origin[3], Float:originF[3];
		pev(victim, pev_origin, originF);
		FVecIVec(originF, origin);
		
	//Spawn glass breaks
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
		write_byte(TE_BREAKMODEL);
		write_coord(origin[0]);		// x
		write_coord(origin[1]);		// y
		write_coord(origin[2] + 24);	// z
		write_coord(1);		// size x
		write_coord(1);		// size y
		write_coord(1);		// size z
		write_coord(random_num(-50,50));// velocity x
		write_coord(random_num(-50,50));// velocity y
		write_coord(25);		// velocity z
		write_byte(10);			// random velocity
		write_short(gGlass);		// model
		write_byte(4);			// count
		write_byte(4);			// life
		write_byte(0x01);		// flags: BREAK_GLASS
		message_end();
	
	//Off Frost Icon
		message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("StatusIcon")  , {0, 0, 0}, victim);
		write_byte(0);
		write_string("dmg_cold");
		message_end(); 
	//Return default speed
		set_pev(victim , pev_maxspeed ,320.0);
	//Delete Ice Shell
		fm_set_rendering(victim);
	}
}
